				__config  _CP_OFF & _XT_OSC & _WDT_OFF & _PWRTE_ON & _LVP_OFF & _BODEN_OFF

				#include "p16f877.inc"  

				DATO    	EQU   H'20'
				INDIRIZZO   EQU   H'21'

				ORG		0x000		
INIZIO
				BSF    	STATUS,RP0     		
				MOVLW	B'11111110'	   		 
				MOVWF	TRISA	   											;
				MOVLW	B'00000000'	  		 
				MOVWF	TRISB
				MOVLW	B'00000000'	  		 
				MOVWF	TRISC	   	  		 
				MOVLW	B'00000000'	   		 
				MOVWF	TRISD				  		 
				MOVLW	B'00001000'		
				MOVWF	TRISE	      		 
	 		 
				MOVLW   0X006 		  		
				MOVWF   ADCON1        		
				MOVLW   B'10000111'		
				MOVWF   OPTION_REG			 
				BCF     STATUS,RP0    		

				CLRF    PORTA
				MOVLW	B'101'				
				MOVWF   PORTE
				CALL    RITARDO
			
				BTFSS   PORTA,4
				GOTO    LEGGI
	
				BSF     PORTA,0
			    CALL    SECTOR_ERASE       

				CLRF    INDIRIZZO
RIPETI
				CALL    READ_EEPROM					
				CALL    RAM_PROGRAM

   				INCF    INDIRIZZO,F
				BCF     STATUS,Z
				CLRW        
				SUBWF   INDIRIZZO,W
				BTFSS   STATUS,Z
				GOTO    RIPETI

LEGGI
				MOVLW   H'00'
				MOVWF   PORTD
				CLRF    PORTB
				CALL    RAM_READ


TERMINA
				GOTO    TERMINA

SECTOR_ERASE				
				MOVLW   H'55'
				MOVWF   PORTD				
				MOVLW   H'55'
				MOVWF   PORTC               

				MOVLW	B'010'				
				MOVWF   PORTE

				MOVLW   H'AA'
				MOVWF   PORTB              
				
				MOVLW   H'2A'
				MOVWF   PORTD				
				MOVLW   H'AA'
				MOVWF   PORTC               
				
				MOVLW	B'011'				
				MOVWF   PORTE

				MOVLW   H'55'
				MOVWF   PORTB              

				MOVLW	B'010'				
				MOVWF   PORTE

				MOVLW   H'55'
				MOVWF   PORTD			
				MOVLW   H'55'
				MOVWF   PORTC               

				MOVLW	B'011'				
				MOVWF   PORTE

				MOVLW   H'80'
				MOVWF   PORTB              

				MOVLW	B'010'				
				MOVWF   PORTE

				MOVLW   H'55'
				MOVWF   PORTD				
				MOVLW   H'55'
				MOVWF   PORTC               

				MOVLW	B'011'				
				MOVWF   PORTE

				MOVLW   H'AA'
				MOVWF   PORTB               

				MOVLW	B'010'				
				MOVWF   PORTE

				MOVLW   H'2A'
				MOVWF   PORTD				
				MOVLW   H'AA'
				MOVWF   PORTC               

				MOVLW	B'011'				
				MOVWF   PORTE

				MOVLW   H'55'
				MOVWF   PORTB              

				MOVLW	B'010'				
				MOVWF   PORTE

				MOVLW   H'00'
				MOVWF   PORTD			
				MOVLW   H'00'
				MOVWF   PORTC             

				MOVLW	B'011'				
				MOVWF   PORTE

				MOVLW   H'30'
				MOVWF   PORTB               

				MOVLW	B'010'				
				MOVWF   PORTE

				MOVLW	B'011'			
				MOVWF   PORTE

				CALL    RITARDO				

			    MOVLW	B'101'			
				MOVWF   PORTE

				RETLW   0

RAM_PROGRAM
				MOVLW   H'55'
				MOVWF   PORTD			
				MOVLW   H'55'
				MOVWF   PORTC               

				MOVLW   H'AA'
				MOVWF   PORTB              

				MOVLW	B'010'				
				MOVWF   PORTE
		
				MOVLW	B'011'				
				MOVWF   PORTE
				
				MOVLW   H'2A'
				MOVWF   PORTD			
				MOVLW   H'AA'
				MOVWF   PORTC               

		     	MOVLW   H'55'
				MOVWF   PORTB              

				MOVLW	B'010'				 
				MOVWF   PORTE	

				MOVLW	B'011'				
				MOVWF   PORTE		

				MOVLW   H'55'
				MOVWF   PORTD				
				MOVLW   H'55'
				MOVWF   PORTC               
				MOVLW   H'A0'
				MOVWF   PORTB               	

				MOVLW	B'010'						
				MOVWF   PORTE

				MOVLW	B'011'				
				MOVWF   PORTE		

				MOVLW   H'00'
				MOVWF   PORTD
			
				MOVF    INDIRIZZO,W			
				MOVWF   PORTC
			
				MOVF    DATO,W				
				MOVWF   PORTB

			    MOVLW	B'010'				 
				MOVWF   PORTE

				MOVLW	B'011'				
				MOVWF   PORTE		

				CALL    RITARDO             

				MOVLW	B'100'				
				MOVWF   PORTE

				RETLW   0

RAM_READ		
				CLRF    PORTC
			    BSF    	STATUS,RP0     		
				MOVLW	B'11111111'	   		 
				MOVWF	TRISB
				BCF     STATUS,RP0

				MOVLW	B'001'				
				MOVWF   PORTE
SOPRA
				INCF    PORTC,F
				GOTO    SOPRA
		
				MOVLW	B'100'				
				MOVWF   PORTE	
				
				RETLW   0

READ_EEPROM
				MOVF 	INDIRIZZO,W  	   
				BSF 	STATUS,RP1         
				MOVWF 	EEADR 		   	    
				BSF 	STATUS,RP0		  
				BCF 	EECON1,EEPGD 	   
				BSF 	EECON1,RD 	       
				BCF 	STATUS,RP0 		   
				MOVF 	EEDATA,W 		   
				BCF 	STATUS,RP1 		   
				MOVWF 	DATO			   
				RETLW	0


RITARDO
                CLRF  	TMR0                  	
                BCF     INTCON,TMR0IF           
LOOP
                BTFSS   INTCON,TMR0IF           
                GOTO    LOOP                    
                RETLW   0                      	 
	
END
